---
title: RTCDataChannel.protocol
slug: Web/API/RTCDataChannel/protocol
tags:
  - Experimental
  - NeedsExample
  - Property
  - Protocol
  - RTCDataChannel
  - Read-only
  - Reference
  - WebRTC
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}</p>

<p>The read-only <code>RTCDataChannel</code> property <code><strong>protocol</strong></code> returns a {{Domxref("DOMString")}} containing the name of the subprotocol in use. If no protocol was specified when the data channel was created, then this property's value is "" (the empty string).</p>

<div class="note">
<p>The permitted values of this property are defined by the Web site or app using the data channel.</p>
</div>

<p>The ability for each channel to have a defined subprotocol lets your app, for example, use JSON objects as messages on one channel while another channel is plaintext and another is raw binary or even some other format.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>subProtocol</em> = <em>aDataChannel</em>.protocol;
</pre>

<h3 id="Value">Value</h3>

<p>A string identifying the app-defined subprotocol being used for exchanging data on the channel. If none has been established, this is an empty string ("").</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var pc = new RTCPeerConnection();
var dc = pc.createDataChannel("my channel", {
           protocol: "json"
});

function handleChannelMessage(dataChannel, msg) {
  switch(dataChannel.protocol) {
    case "json":
      /* process JSON data */
      break;
    case "raw":
      /* process raw binary data */
      break;
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-datachannel-protocol', 'RTCDataChannel.protocol') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel.protocol")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
 <li>{{domxref("RTCDataChannel")}}</li>
 <li>{{domxref("RTCPeerConnection.createDataChannel()")}}</li>
</ul>
